const char _binary_chromakey_sl_start[] =
"uniform sampler2D tex;\n"
"uniform float red;\n"
"uniform float green;\n"
"uniform float blue;\n"
"uniform float in_slope;\n"
"uniform float out_slope;\n"
"uniform float tolerance;\n"
"uniform float tolerance_in;\n"
"uniform float tolerance_out;\n"
"uniform float sat;\n"
"uniform float min_s;\n"
"uniform float min_s_in;\n"
"uniform float min_s_out;\n"
"uniform float min_v;\n"
"uniform float min_v_in;\n"
"uniform float min_v_out;\n"
"uniform float max_v;\n"
"uniform float max_v_in;\n"
"uniform float max_v_out;\n"
"uniform float spill_threshold;\n"
"uniform float spill_amount;\n"
"uniform float alpha_offset;\n"
"uniform float hue_key;\n"
"uniform float saturation_key;\n"
"uniform float value_key;\n"
"\n"
"void main()\n"
"{\n"
"	vec4 color = texture2D(tex, gl_TexCoord[0].st);\n"
"/* Contribution to alpha from each component */\n"
"	float alpha_value = 1.0;\n"
"	float alpha_value_max = 1.0;\n"
"	float alpha_hue = 1.0;\n"
"	float alpha_saturation = 1.0;\n"
"	bool has_match = true;\n"
"	vec4 color2;\n"
"	\n"
"/* Convert to HSV */\n"
"	color2 = yuv_to_rgb(color);\n"
"	color2 = rgb_to_hsv(color2);\n"
"\n"
"/* Hue is completely out of range */\n"
"	if (tolerance == 0.0)\n"
"	    alpha_hue = 1.0;\n"
"	else\n"
"	if (abs(color2.r - hue_key) < tolerance_in * 180.0)\n"
"		alpha_hue = 0.0;\n"
"	else \n"
"	if ((out_slope != 0.0 ) && (abs(color2.r - hue_key) < tolerance * 180.0)) \n"
"/* If using slope, scale alpha between 0 and 1 / 2 */\n"
"		alpha_hue = abs(color2.r - hue_key) / tolerance / 360.0; \n"
"	else \n"
"	if (abs(color2.r - hue_key) < tolerance_out * 180.0) \n"
"/* If no slope, scale alpha between 1/2 and 1 */\n"
"		alpha_hue = abs(color2.r - hue_key) / tolerance_out / 360.0; \n"
"	else\n"
"		has_match = false;	\n"
"\n"
"/* Test saturation */\n"
"	if (has_match) \n"
"	{\n"
"		if (min_s == 0.0)\n"
"			alpha_saturation = 0.0;\n"
"		else \n"
"		if ( color2.g - sat >= min_s_in )\n"
"			alpha_saturation = 0.0;\n"
"		else \n"
"		if ((out_slope != 0.0) && ( color2.g - sat > min_s ) )\n"
"			alpha_saturation = (color2.g - sat - min_s) / (min_s * 2.0);\n"
"		else \n"
"		if ( color2.g - sat > min_s_out ) \n"
"			alpha_saturation = (color2.g - sat - min_s_out) / (min_s_out * 2.0);\n"
"		else \n"
"			has_match = false;\n"
"	}\n"
"\n"
"/* Test value over minimum */\n"
"	if (has_match)\n"
"	{\n"
"	    if (min_v == 0.0)\n"
"			alpha_value = 0.0;\n"
"		else \n"
"		if ( color2.b >= min_v_in )\n"
"			alpha_value = 0.0;\n"
"		else \n"
"		if ((out_slope != 0.0) && ( color2.b > min_v ) )\n"
"			alpha_value = (color2.b - min_v) / (min_v * 2.0);\n"
"		else \n"
"		if ( color2.b > min_v_out )\n"
"			alpha_value = (color2.b - min_v_out) / (min_v_out * 2.0);\n"
"		else\n"
"			has_match = false;\n"
"	}\n"
"\n"
"/* Test value under maximum */\n"
"	if (has_match)\n"
"	{\n"
"	    if (max_v == 0.0)\n"
"			alpha_value_max = 1.0;\n"
"	    else \n"
"		if (color2.b <= max_v_in)\n"
"			alpha_value_max = 0.0;\n"
"	    else \n"
"		if ((out_slope != 0.0) && (color2.b < max_v))\n"
"			alpha_value_max = (color2.b - max_v) / (max_v * 2.0);\n"
"	    else \n"
"		if (color2.b < max_v_out)\n"
"			alpha_value_max = (color2.b - max_v_out) / (max_v_out * 2.0);\n"
"	    else\n"
"			has_match = false;\n"
"	}\n"
"\n"
"/* Take largest component as the alpha */\n"
"	if (has_match)\n"
"	   	color2.a = max (max (alpha_hue, alpha_value), max (alpha_saturation, alpha_value_max));\n"
"\n"
"/* Spill light processing */\n"
"	if ((abs(color2.r - hue_key) < spill_threshold * 180.0) || \n"
"	    ((abs(color2.r - hue_key) > 360.0) && \n"
"	    (abs(color2.r - hue_key) - 360.0 < spill_threshold * 180.0)))\n"
"	{\n"
"/* Modify saturation based on hue contribution */\n"
"	    color2.g = color2.g * \n"
"			spill_amount * \n"
"			abs(color2.r - hue_key) / \n"
"			(spill_threshold * 180.0);\n"
"\n"
"/* convert back to native colormodel */\n"
"		color2 = hsv_to_rgb(color2);\n"
"		color.rgb = rgb_to_yuv(color2).rgb;\n"
"	}\n"
"\n"
"\n"
"/* Convert mask into image */\n"
"	gl_FragColor = show_mask(color, color2);\n"
"}\n"
"\n"
"\n"
;
